"use strict";
require('reflect-metadata');
const orm = require('./orm');
function Entity() {
    return (target) => {
        // let tableName = changeCase.snake(target.name);
    };
}
exports.Entity = Entity;
function inherits(base) {
    return (target) => {
        let table = orm.schema.getTable(target);
        let baseTable = orm.schema.getTable(base);
        table.extends = baseTable;
        baseTable.extendedBy.push(table);
        // todo: error if baseTable.idField is not available
        table.idField = table.createField(baseTable.idField.name, baseTable.idField.type);
    };
}
exports.inherits = inherits;
function field() {
    return (target, propertyKey) => {
        let type = Reflect.getMetadata('design:type', target, propertyKey);
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        let field;
        if (table.hasField(fieldName)) {
            field = table.getField(fieldName);
            field.type = type;
        }
        else {
            field = table.createField(fieldName, type);
        }
        if (type == Array)
            field.isArray = true;
    };
}
exports.field = field;
function associate(ref, reversedBy) {
    return (target, propertyKey) => {
        exports.field()(target, propertyKey);
        if (!ref)
            return; // expecting reversed ref from yet unknown ref
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        let field = table.getField(fieldName);
        let refTable = orm.schema.getTable(ref);
        let refField = refTable.getField(reversedBy);
        if (!refField) {
            throw new Error(`Unknown field ${reversedBy} in ${refTable.name}, referenced by ${tableName}.${fieldName}.`);
        }
        field.associate(refField);
    };
}
exports.associate = associate;
function id(options = {}) {
    return (target, propertyKey) => {
        exports.field()(target, propertyKey);
        let tableName = target.constructor.name;
        let fieldName = propertyKey;
        let table = orm.schema.getTable(target.constructor);
        let field = table.getField(fieldName);
        if (options.coalition) {
            let coalition = [];
            if (typeof options.coalition == 'string') {
                coalition = options.coalition.split(/[\s,]+/);
            }
            else {
                coalition = options.coalition;
            }
            if (coalition.length > 0) {
                table.idFields = [field];
                for (let partner of coalition) {
                    exports.field()(target, partner);
                    let partnerField = table.getField(partner);
                    table.idFields.push(partnerField);
                }
            }
            else {
                table.idField = field;
            }
        }
        else {
            table.idField = field;
        }
    };
}
exports.id = id;
//# sourceMappingURL=decorators.js.map